package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WXMessage;
import com.sa.ibiz.demo.demo.service.WXMessageService;
import com.sa.ibiz.demo.demo.service.dto.WXMessageSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wxmessage")
public class WXMessageResource
{
	@Autowired
	private WXMessageService service;


	@PostMapping(value = "/update")
	public ResponseEntity<WXMessage> update(@Validated @RequestBody WXMessage data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("微信消息[update]操作发生错误","WXMessage",data.getWxmessageid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WXMessage> get(@Validated @PathVariable String id){
		WXMessage data=new WXMessage();
		data.setWxmessageid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("微信消息[get]操作发生错误","WXMessage",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WXMessage> getDraft(@Validated @RequestBody WXMessage data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("微信消息[getDraft]操作发生错误","WXMessage","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WXMessage> create(@Validated @RequestBody WXMessage data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("微信消息[create]操作发生错误","WXMessage",data.getWxmessageid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WXMessage> remove(@Validated @RequestBody WXMessage data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("微信消息[remove]操作发生错误","WXMessage",data.getWxmessageid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WXMessage> checkKey(@Validated @RequestBody WXMessage data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("微信消息[checkKey]操作发生错误","WXMessage",data.getWxmessageid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WXMessage>> searchDefaultPage(@Validated @RequestBody WXMessageSearchFilter filter){
		Page<WXMessage> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WXMessage>> listDefault(@Validated @RequestBody WXMessageSearchFilter filter){
		List<WXMessage> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
